
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>详解Android中Handler的使用方法_Android / iVAN</title>

    <meta name="description" content="详解Android中Handler的使用方法_Android 在Android开发中,我们经常会遇到这样一种情况:在UI界面上进行某项操作后要执行一段很耗时的代码,比如我们在界面上点击了一个&quot;下载&quot;按钮,那么我们需要执行网络请求,这是一个耗时操作,因为不知道什么时候才能完成.为了保证不影响UI线程,所以我们会创建一个新的线程去执行我们的耗时的代码.当我们的耗时操作完成时,我们需要更新UI界面以告知用户操作完成了.所以我们可能会写出如下的代码: package ispring.com.testhandler; import android ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">详解Android中Handler的使用方法_Android</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>在Android开发中，我们经常会遇到这样一种情况：在UI界面上进行某项操作后要执行一段很耗时的代码，比如我们在界面上点击了一个”下载“按钮，那么我们需要执行网络请求，这是一个耗时操作，因为不知道什么时候才能完成。为了保证不影响UI线程，所以我们会创建一个新的线程去执行我们的耗时的代码。当我们的耗时操作完成时，我们需要更新UI界面以告知用户操作完成了。所以我们可能会写出如下的代码:</p>
<pre>
package ispring.com.testhandler;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

public class MainActivity extends Activity implements Button.OnClickListener {

 private TextView statusTextView = null;

 @Override
 protected void onCreate(Bundle savedInstanceState) {
  super.onCreate(savedInstanceState);
  setContentView(R.layout.activity_main);
  statusTextView = (TextView)findViewById(R.id.statusTextView);
  Button btnDownload = (Button)findViewById(R.id.btnDownload);
  btnDownload.setOnClickListener(this);
 }

 @Override
 public void onClick(View v) {
  DownloadThread downloadThread = new DownloadThread();
  downloadThread.start();
 }

 class DownloadThread extends Thread{
  @Override
  public void run() {
   try{
    System.out.println("开始下载文件");
    //此处让线程DownloadThread休眠5秒中，模拟文件的耗时过程
    Thread.sleep(5000);
    System.out.println("文件下载完成");
    //文件下载完成后更新UI
    MainActivity.this.statusTextView.setText("文件下载完成");
   }catch (InterruptedException e){
    e.printStackTrace();
   }
  }
 }
}
</pre>
<p>上面的代码演示了单击”下载“按钮后会启动一个新的线程去执行实际的下载操作，执行完毕后更新UI界面。但是在实际运行到代码MainActivity.this.statusTextView.setText(“文件下载完成”)时，会报错如下，系统崩溃退出： <br />
android.view.ViewRootImpl$CalledFromWrongThreadException: Only the original thread that created a view hierarchy can touch its views. <br />
错误的意思是只有创建View的原始线程才能更新View。出现这样错误的原因是Android中的View不是线程安全的，在Android应用启动时，会自动创建一个线程，即程序的主线程，主线程负责UI的展示、UI事件消息的派发处理等等，因此主线程也叫做UI线程，statusTextView是在UI线程中创建的，当我们在DownloadThread线程中去更新UI线程中创建的statusTextView时自然会报上面的错误。Android的UI控件是非线程安全的，其实很多平台的UI控件都是非线程安全的，比如C#的.Net Framework中的UI控件也是非线程安全的，所以不仅仅在Android平台中存在从一个新线程中去更新UI线程中创建的UI控件的问题。不同的平台提供了不同的解决方案以实现跨线程跟新UI控件，Android为了解决这种问题引入了Handler机制。</p>
<p>那么Handler到底是什么呢？Handler是Android中引入的一种让开发者参与处理线程中消息循环的机制。每个Hanlder都关联了一个线程，每个线程内部都维护了一个消息队列MessageQueue，这样Handler实际上也就关联了一个消息队列。可以通过Handler将Message和Runnable对象发送到该Handler所关联线程的MessageQueue（消息队列）中，然后该消息队列一直在循环拿出一个Message，对其进行处理，处理完之后拿出下一个Message，继续进行处理，周而复始。当创建一个Handler的时候，该Handler就绑定了当前创建Hanlder的线程。从这时起，该Hanlder就可以发送Message和Runnable对象到该Handler对应的消息队列中，当从MessageQueue取出某个Message时，会让Handler对其进行处理。</p>
<p>Handler可以用来在多线程间进行通信，在另一个线程中去更新UI线程中的UI控件只是Handler使用中的一种典型案例，除此之外，Handler可以做很多其他的事情。每个Handler都绑定了一个线程，假设存在两个线程ThreadA和ThreadB，并且HandlerA绑定了 ThreadA，在ThreadB中的代码执行到某处时，出于某些原因，我们需要让ThreadA执行某些代码，此时我们就可以使用Handler，我们可以在ThreadB中向HandlerA中加入某些信息以告知ThreadA中该做某些处理了。由此可以看出，Handler是Thread的代言人，是多线程之间通信的桥梁，通过Handler，我们可以在一个线程中控制另一个线程去做某事。</p>
<p>Handler提供了两种方式解决我们在本文一开始遇到的问题（在一个新线程中更新主线程中的UI控件），一种是通过post方法，一种是调用sendMessage方法。</p>
<p><strong>a. 使用post方法，代码如下：</strong></p>
<pre>
package ispring.com.testhandler;

import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

public class MainActivity extends Activity implements Button.OnClickListener {

 private TextView statusTextView = null;

 //uiHandler在主线程中创建，所以自动绑定主线程
 private Handler uiHandler = new Handler();

 @Override
 protected void onCreate(Bundle savedInstanceState) {
  super.onCreate(savedInstanceState);
  setContentView(R.layout.activity_main);
  statusTextView = (TextView)findViewById(R.id.statusTextView);
  Button btnDownload = (Button)findViewById(R.id.btnDownload);
  btnDownload.setOnClickListener(this);
  System.out.println("Main thread id " + Thread.currentThread().getId());
 }

 @Override
 public void onClick(View v) {
  DownloadThread downloadThread = new DownloadThread();
  downloadThread.start();
 }

 class DownloadThread extends Thread{
  @Override
  public void run() {
   try{
    System.out.println("DownloadThread id " + Thread.currentThread().getId());
    System.out.println("开始下载文件");
    //此处让线程DownloadThread休眠5秒中，模拟文件的耗时过程
    Thread.sleep(5000);
    System.out.println("文件下载完成");
    //文件下载完成后更新UI
    Runnable runnable = new Runnable() {
     @Override
     public void run() {
      System.out.println("Runnable thread id " + Thread.currentThread().getId());
      MainActivity.this.statusTextView.setText("文件下载完成");
     }
    };
    uiHandler.post(runnable);
   }catch (InterruptedException e){
    e.printStackTrace();
   }
  }
 }
}
</pre>
<p>我们在Activity中创建了一个Handler成员变量uiHandler，Handler有个特点，在执行new Handler()的时候，默认情况下Handler会绑定当前代码执行的线程，我们在主线程中实例化了uiHandler，所以uiHandler就自动绑定了主线程，即UI线程。当我们在DownloadThread中执行完耗时代码后，我们将一个Runnable对象通过post方法传入到了Handler中，Handler会在合适的时候让主线程执行Runnable中的代码，这样Runnable就在主线程中执行了，从而正确更新了主线程中的UI。以下是输出结果：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE1MTIxNjEwMTQwNzEzOC5wbmc=.jpg"></p>
<p>通过输出结果可以看出，Runnable中的代码所执行的线程ID与DownloadThread的线程ID不同，而与主线程的线程ID相同，因此我们也由此看出在执行了Handler.post(Runnable)这句代码之后，运行Runnable代码的线程与Handler所绑定的线程是一致的，而与执行Handler.post(Runnable)这句代码的线程（DownloadThread）无关。</p>
<p><strong>b. 使用sendMessage方法，代码如下：</strong></p>
<pre>
package ispring.com.testhandler;

import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

public class MainActivity extends Activity implements Button.OnClickListener {

 private TextView statusTextView = null;

 //uiHandler在主线程中创建，所以自动绑定主线程
 private Handler uiHandler = new Handler(){
  @Override
  public void handleMessage(Message msg) {
   switch (msg.what){
    case 1:
     System.out.println("handleMessage thread id " + Thread.currentThread().getId());
     System.out.println("msg.arg1:" + msg.arg1);
     System.out.println("msg.arg2:" + msg.arg2);
     MainActivity.this.statusTextView.setText("文件下载完成");
     break;
   }
  }
 };

 @Override
 protected void onCreate(Bundle savedInstanceState) {
  super.onCreate(savedInstanceState);
  setContentView(R.layout.activity_main);
  statusTextView = (TextView)findViewById(R.id.statusTextView);
  Button btnDownload = (Button)findViewById(R.id.btnDownload);
  btnDownload.setOnClickListener(this);
  System.out.println("Main thread id " + Thread.currentThread().getId());
 }

 @Override
 public void onClick(View v) {
  DownloadThread downloadThread = new DownloadThread();
  downloadThread.start();
 }

 class DownloadThread extends Thread{
  @Override
  public void run() {
   try{
    System.out.println("DownloadThread id " + Thread.currentThread().getId());
    System.out.println("开始下载文件");
    //此处让线程DownloadThread休眠5秒中，模拟文件的耗时过程
    Thread.sleep(5000);
    System.out.println("文件下载完成");
    //文件下载完成后更新UI
    Message msg = new Message();
    //虽然Message的构造函数式public的，我们也可以通过以下两种方式通过循环对象获取Message
    //msg = Message.obtain(uiHandler);
    //msg = uiHandler.obtainMessage();

    //what是我们自定义的一个Message的识别码，以便于在Handler的handleMessage方法中根据what识别
    //出不同的Message，以便我们做出不同的处理操作
    msg.what = 1;

    //我们可以通过arg1和arg2给Message传入简单的数据
    msg.arg1 = 123;
    msg.arg2 = 321;
    //我们也可以通过给obj赋值Object类型传递向Message传入任意数据
    //msg.obj = null;
    //我们还可以通过setData方法和getData方法向Message中写入和读取Bundle类型的数据
    //msg.setData(null);
    //Bundle data = msg.getData();

    //将该Message发送给对应的Handler
    uiHandler.sendMessage(msg);
   }catch (InterruptedException e){
    e.printStackTrace();
   }
  }
 }
}
</pre>
<p>通过Message与Handler进行通信的步骤是：</p>
<ul>
<li>1. 重写Handler的handleMessage方法，根据Message的what值进行不同的处理操作</li>
<li>2. 创建Message对象</li>
<li>虽然Message的构造函数式public的,我们还可以通过Message.obtain()或Handler.obtainMessage()来获得一个Message对象（Handler.obtainMessage()内部其实调用了Message.obtain()）。</li>
<li>3. 设置Message的what值</li>
<li>Message.what是我们自定义的一个Message的识别码，以便于在Handler的handleMessage方法中根据what识别出不同的Message，以便我们做出不同的处理操作。</li>
<li>4. 设置Message的所携带的数据，简单数据可以通过两个int类型的field arg1和arg2来赋值，并可以在handleMessage中读取。</li>
<li>5. 如果Message需要携带复杂的数据，那么可以设置Message的obj字段，obj是Object类型，可以赋予任意类型的数据。或者可以通过调用Message的setData方法赋值Bundle类型的数据，可以通过getData方法获取该Bundle数据。</li>
<li>6. 我们通过Handler.sendMessage(Message)方法将Message传入Handler中让其在handleMessage中对其进行处理。</li>
</ul>
<p>需要说明的是，如果在handleMessage中 不需要判断Message类型，那么就无须设置Message的what值；而且让Message携带数据也不是必须的，只有在需要的时候才需要让其携带数据；如果确实需要让Message携带数据，应该尽量使用arg1或arg2或两者，能用arg1和arg2解决的话就不要用obj，因为用arg1和arg2更高效。 <br />
程序的运行结果如下：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE1MTIxNjEwMTQzNTgzNC5wbmc=.jpg"></p>
<p>由上我们可以看出，执行handleMessage的线程与创建Handler的线程是同一线程，在本示例中都是主线程。执行handleMessage的线程与执行uiHandler.sendMessage(msg)的线程没有关系。</p>
<p>本文主要是对Android中Handler的作用于如何使用进行了初步介绍，如果大家想了解Handler的内部实现原理，可以参见下一篇博文《深入源码解析Android中的Handler,Message,MessageQueue,Looper》。</p>
<p>以上是小编为您精心准备的的内容，在的博客、问答、公众号、人物、课程等栏目也有的相关内容，欢迎继续使用右上角搜索按钮进行搜索android<br />
                                    handler<br />
                                    android handler详解、android handler使用、handler使用方法、handler的使用方法、android beam使用详解，以便于您获取更多的相关知识。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-02 02:36:55</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/android/" title="android">android</a>, <a href="https://www.iamivan.net/tag/handler/" title="handler">handler</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>详解Android中Handler的使用方法_Android的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b2Pxwop.html" rel="bookmark">详解Android中Intent的使用方法&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.Intent的用途 Intent主要有以下几种重要用途: 1. 启动Activity:可以将Intent对象传递给startActivity()方法或startActivityForResult()方法以启动一个Activity,该Intent对象包含了要启动的Activity的信息及其他必要的数据. 2. 启动Service:可以将Intent对象传递给startService()方法或bindService()方法以启动一个Service,该Intent对象包含了要启动的Service的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgV4Jmb.html" rel="bookmark">详解Android中IntentService的使用方法&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				为什么我们需要IntentService ? Android中的IntentService是继承自Service类的,在我们讨论IntentService之前,我们先想一下Service的特点: Service的回调方法(onCreate.onStartCommand.onBind.onDestroy)都是运行在主线程中的.当我们通过startService启动Service之后,我们就需要在Service的onStartCommand方法中写代码完成工作,但是onStartCommand是运行			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ba6a1nM.html" rel="bookmark">详解Android中解析XML的方法&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				XML在各种开发中都广泛应用,Android也不例外.作为承载数据的一个重要角色,如何读写XML成为Android开发中一项重要的技能.今天就由我向大家介绍一下在Android平台下几种常见的XML解析和创建的方法. 在Android中,常见的XML解析器分别为SAX解析器.DOM解析器和PULL解析器,下面,我将一一向大家详细介绍. SAX解析器: SAX(Simple API for XML)解析器是一种基于事件的解析器,它的核心是事件处理模式,主要是围绕着事件源以及事件处理器来工作的.当事			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKqm1Op.html" rel="bookmark">详解Android中Handler的实现原理&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在 Android 中,只有主线程才能操作 UI,但是主线程不能进行耗时操作,否则会阻塞线程,产生 ANR 异常,所以常常把耗时操作放到其它子线程进行.如果在子线程中需要更新 UI,一般是通过 Handler 发送消息,主线程接受消息并且进行相应的逻辑处理.除了直接使用 Handler,还可以通过 View 的 post 方法以及 Activity 的 runOnUiThread 方法来更新 UI,它们内部也是利用了 Handler .在上一篇文章 Android AsyncTask源码分析 中			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQr39OM.html" rel="bookmark">详解Android中Notification的使用方法&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				      在消息通知的时候,我们经常用到两个控件Notification和Toast.特别是重要的和需要长时间显示的信息,用Notification最合适不过了.他可以在顶部显示一个图标以标示有了新的通知,当我们拉下通知栏的时候,可以看到详细的通知内容.       最典型的应用就是未看短信和未接来电的显示,还有QQ微信,我们一看就知道有一个未接来电或者未看短信,收到QQ离线信息.同样,我们也可以自定义一个Notification来定义我们自己的程序想要传达的信息. Notification我			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MR9r2Bb.html" rel="bookmark">详解Android中weight的使用方法&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				android中对weight的学习可以说是必须的,如果UI布局仅仅使用dp与sp等等,会让布局显得极度不灵活,毕竟各个手机屏幕大小不同,更别说是还有ipad之类的了,所以也是同做本人近期做的一个小UI来分享一下weight的使用.         左边是各个屏幕的显示效果,右边是1080*1920屏幕的具体显示效果.可以看到,不管屏幕如何变化,使用weight的布局中总是填充满屏幕的,至于美观效果就不说了,直接上代码. 小编使用的android studio,eclipse用户直接复制肯定会有			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pn7A00z.html" rel="bookmark">详解Android中Handler的内部实现原理&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文主要是对Handler和消息循环的实现原理进行源码分析,如果不熟悉Handler可以参见博文&lt;详解Android中Handler的使用方法&gt;,里面对Android为何以引入Handler机制以及如何使用Handler做了讲解. 概括来说,Handler是Android中引入的一种让开发者参与处理线程中消息循环的机制.我们在使用Handler的时候与Message打交道最多,Message是Hanlder机制向开发人员暴露出来的相关类,可以通过Message类完成大部分操作Handler的功			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mymx08M.html" rel="bookmark">详解Android中AsyncTask的使用方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在Android中实现异步任务机制有两种方式,Handler和AsyncTask. Handler模式需要为每一个任务创建一个新的线程,任务完成后通过Handler实例向UI线程发送消息,完成界面的更新,这种方式对于整个过程的控制比较精细,但也是有缺点的,例如代码相对臃肿,在多个任务同时执行时,不易对线程进行精确的控制. 为了简化操作,Android1.5提供了工具类android.os.AsyncTask,它使创建异步任务变得更加简单,不再需要编写任务线程和Handler实例即可完成相同的任务			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z46E1jM.html" rel="bookmark">详解Android中解析XML的方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				XML在各种开发中都广泛应用,Android也不例外.作为承载数据的一个重要角色,如何读写XML成为Android开发中一项重要的技能.今天就由我向大家介绍一下在Android平台下几种常见的XML解析和创建的方法. 在Android中,常见的XML解析器分别为SAX解析器.DOM解析器和PULL解析器,下面,我将一一向大家详细介绍. SAX解析器: SAX(Simple API for XML)解析器是一种基于事件的解析器,它的核心是事件处理模式,主要是围绕着事件源以及事件处理器来工作的.当事			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vbQryWM.html" rel="bookmark" class="title">oracle-Oracle BIEE技术Oracle BIEE能做鼠标悬停提示的那种效果吗？</a>
					<div>
						问题描述 Oracle BIEE技术Oracle BIEE能做鼠标悬停提示的那种效果吗? 请问下各位大神,Oracle BIEE能做鼠标悬停提示的那种效果吗? 解决方案 自己来回答,请参考这篇文章ht ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qMq7Oaz.html" rel="bookmark" class="title">ruby解决猴子大王问题</a>
					<div>
						class Ring def initialize(n=10) @array = (1..n).to_a @pos = 0 end def next_del raise &quot;just left ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVndDBz.html" rel="bookmark" class="title">如何加快Excel 2010的打开速度</a>
					<div>
						设定方法如下:文件菜单,选项, &quot;加载项&quot;-----转到 可以选中或取消选中,最后点确定即可以. 查看本栏目更多精彩内容:http://www.bianceng.cnhttp:// ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgKyv3M.html" rel="bookmark" class="title">Java Web Start入门教程</a>
					<div>
						版权所有:(xiaodaoxiaodao)蓝小刀 xiaodaoxiaodao@gmail.com http://www.blogjava.net/xiaodaoxiaodao/articles/10 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvKEVrp.html" rel="bookmark" class="title">Spring学习点滴，《Spring in Action》笔记（三）</a>
					<div>
						第十章. 使用其他 Web 框架 41. Spring 提供了两种与 Struts 集成的方式 1) 让你的 Action 继承 org.springframework.web.struts.Acti ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOwEKRz.html" rel="bookmark" class="title">网页中的丝带和标牌设计英文教程</a>
					<div>
						潮流会静静地诞生于我们未留意之时.当你浏览众多网站时,通常会看见自己在别处错过的花纹.图案.其中就包括丝带和标牌. 这两种图案越来越流行,文中将它们放在一起讨论,因为它们大都同时使用,丝带不言而喻,大 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLOx7RM.html" rel="bookmark" class="title">photoshop打造柔滑绸缎字体教程</a>
					<div>
						平时制作海报,广告等图片时,吸引人的字体也是必不可少的,本教程就为大家介绍如何制作柔滑精美的绸缎艺术字. photoshop教程最终效果 1.新建一个800 * 800 像素文件,选择渐变工具,颜色设 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPeaGz.html" rel="bookmark" class="title">Win8&period;1系统运行风暴语音出错怎么办</a>
					<div>
						  Win8.1系统运行风暴语音出错怎么办           风暴语音是一款游戏模拟器,在Windows8.1系统下许多用户反映无法运行风暴语音,总弹出提示&quot;sorry,this appl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3oJwAb.html" rel="bookmark" class="title">如何利用注册表恢复回收站中被删除的文件</a>
					<div>
						  1.按Win+R键,打开运行,输入regedit,回车进入注册表编辑器; 2.展开至HKEY_LOCAL_MACHINESOFTWAREMicrosoftWindowsCurrentVersion ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYR7Kxp.html" rel="bookmark" class="title">迅雷高速通道按钮消失不能用怎么办</a>
					<div>
						  1.正常情况,高速通道按钮可以点击,如下图: 2.高速通道按钮灰色,如图: 3.高速通道按钮消失,如图: 4.解决方法 通过迅雷7或迅雷极速版 =&gt;系统设置(快捷键Alt+O)=&gt;我的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6e63Wb.html" rel="bookmark" class="title">360云盘关闭后里面的文件怎么办？</a>
					<div>
						  360云盘关闭后里面的文件怎么办 360云盘发布公告表示,将停止个人云盘服务,在网盘存储.传播内容的合法性和安全性得到彻底解决之前不再考虑恢复,之后转型企业云服务. 对于停止原因,公告表示部分不法 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Nm3Bz.html" rel="bookmark" class="title">城市地图-sql 全国城市地区更新问题</a>
					<div>
						问题描述 sql 全国城市地区更新问题 是这样的,之前公司的城市地区数据库已经有了一部分的全国城市数据,但是现在发现之前的数据缺失了好多,但是,现在公司已经在运行中,没法修改之前的数据,只能更新,但是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwx0Vkb.html" rel="bookmark" class="title">autowired-SpringMVC&plus;Spring Controller自动装配失败</a>
					<div>
						问题描述 SpringMVC+Spring Controller自动装配失败 使用SpringMVC+Hibernate+Spring做demo练习,但是启动时报错,说是Controller里依赖的L ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDWg3rp.html" rel="bookmark" class="title">说说 DWRUtil</a>
					<div>
						说说 DWRUtil 比如我们从服务器端获得了一个citylist的数据,要把这些数据放到id为city的一个下拉列表中,它有这么两个属性id ,name.我们要用id作为下拉列表的value,nam ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQBj1OM.html" rel="bookmark" class="title">电视盒子取代有线电视是一个伪命题</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断淘宝客 站长团购 云主机 技术大厅 以爱奇艺和乐视为首的视频巨 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlKn38b.html" rel="bookmark" class="title">浅谈云南建站私活与公司二者之间的利弊</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 做了许久的网站设计,对云南网站私活 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL7QmWM.html" rel="bookmark" class="title">中山启动首届&OpenCurlyDoubleQuote;万名家长学电脑&rdquo;活动</a>
					<div>
						今年6月至10月,是全国第七个家庭道德教育宣传实践月.日前,中山启动了首届2010年&quot;万名家长学电脑&quot;活动. &quot;万名家长学电脑&quot;活动重点以农村学校和流动儿童集中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkAeYdb.html" rel="bookmark" class="title">java实现创建临时文件然后在程序退出时自动删除文件&lowbar;java</a>
					<div>
						通过java的File类创建临时文件,然后在程序退出时自动删除临时文件.下面将通过创建一个JFrame界面,点击创建按钮在当前目录下面创建temp文件夹且创建一个以mytempfile******.t ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBkgLNM.html" rel="bookmark" class="title">用ASP实现对ORACLE数据库的操作&lowbar;应用技巧</a>
					<div>
						ASP(Active Server Pages)是微软公司为开发互联网应用程序所提出的工具之一,ASP与数据库的联接一般通过ADO(Activex Data Object)来实现的,就象&lt;计算机 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Q60Dp.html" rel="bookmark" class="title">innerHTML中标签可以换行的方法汇总&lowbar;javascript技巧</a>
					<div>
						在用innerHTML生成结构时,为了看起来结构明快,可以在每行的末尾加一个反斜线\,即可保持html原结构,而不至于将标签都挤在一块 &lt;!DOCTYPE html&gt; &lt;html l ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwKmNOz.html" rel="bookmark" class="title">使用PHPMailer实现邮件发送代码分享&lowbar;php实例</a>
					<div>
						发送邮件是常用的功能,LZ今天在项目中也碰到了,特此分享一下. 首先,去下载PHPMailer 1.https://github.com/dwqs/PHPMailer 2.http://downloa ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2ZADVb.html" rel="bookmark" class="title">Java实现获取前、后N天日期的函数分享&lowbar;java</a>
					<div>
						代码很简单,功能也很实用,这里就不多废话了. public Date getdate(int i) // //获取前后日期 i为正数 向后推迟i天,负数时向前提前i天 { Date dat = nul ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJOxD4b.html" rel="bookmark" class="title">基于JQuery的多标签实现代码&lowbar;jquery</a>
					<div>
						今天要分享的是基于JQuery实现的多标签的切换,JQuery就不用过多介绍了,网上一搜一大堆资料,当然这样的小示例也有很多,这里只是发表一些自己的想法. 下面是本次示例所使用的HTML页面: 复制代 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9j7EKp.html" rel="bookmark" class="title">Google揭密PageRank技术</a>
					<div>
						编者按:透过位于山景城的一家搜索引擎公司的一份专利申请书,可以中让我们对这个搜索引擎的PageRank技术内幕多一些了解. 域名注册时限 作为一个合法的网站拥有者来说,无不希望自己的域名注册至少已有一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boqOD3p.html" rel="bookmark" class="title">怎么调用使用eclipse bpel组合的web服务？？</a>
					<div>
						问题描述 我想用jsp界面调用服务,原子服务可以单独调用,但是用bpel组合以后就不能调用了贴个调用原子服务的代码publicStringgetstring(){Stringret=null;try{ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0YBlJp.html" rel="bookmark" class="title">这些成功营销案例中的&OpenCurlyDoubleQuote;私人订制&rdquo;，你知道吗？</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 电影&lt;私人订制&gt;,以圆梦四人组为客户圆梦为主线,演绎了一场为客户订制梦想的戏码. 电影公映后,掀起了一场对于社会上私人订制的讨论.其实,在各 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zG1O33M.html" rel="bookmark" class="title">浅谈网站死链出错404页面问题</a>
					<div>
						网站出现死链是很平常的事情,绝大多数站长们都没有一个好的习惯,都没有去整理这个404出错页面.这方面既导致了用户体验失效,且导致SEO出现负面效果. 前几天,我一个朋友的客户网站有很多死链,原因就是因 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk7NK5p.html" rel="bookmark" class="title">昨天发现一个非常不错的抽象工厂视频，与大家分享</a>
					<div>
						问题描述 这个&quot;抽象工厂&quot;视频偶收藏了,好像就是前几天发的.http://v.youku.com/v_show/id_XMjYwNjE3NDA4.html					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDXrOBz.html" rel="bookmark" class="title">《Java EE 7精粹》&mdash;&mdash; 3&period;12 Passthrough属性和HTML5友好的标记</a>
					<div>
						3.12 Passthrough属性和HTML5友好的标记 HTML5为现有的HTML元素增加了一系列的新属性.这些属性包括input元素的type属性,可以支持例如电子邮件.网址.电话.数量.范围和 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmd75BM.html" rel="bookmark" class="title">研究发现有加密货币僵尸服务器在WannaCry蠕虫前利用微软漏洞</a>
					<div>
						上周五,名为WannaCry的勒索蠕虫利用从美国安全局泄露的入侵工具在全球150个国家感染了20万台电脑.本周一,研究人员表示在此之前就有规模更大的攻击感染了全球多台电脑并把他们作为&quot;埋伏& ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
